/*
 * Copyright (c) 2002 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by '../scripts/clnt-gen'.
 */

#ident "$XORP: xorp/xrl/interfaces/finder_client_xif.cc,v 1.1.1.1 2002/12/11 23:56:17 hodson Exp $"

#include "finder_client_xif.hh"

bool
XrlFinderClientV0p1Client::send_hello(
	const char*	the_tgt, 
	const CB0&	cb
)
{
    Xrl x(the_tgt, "finder_client/0.1/hello");
    return _router->send(x, callback(this, &XrlFinderClientV0p1Client::unmarshall0, cb));
}


/* Unmarshall hello */
void
XrlFinderClientV0p1Client::unmarshall0(
	const XrlError&	e, 
	XrlRouter&	/* r */, 
	const Xrl&	/* x */, 
	XrlArgs*	a, 
	CB0		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%d != 0)", a->size());
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlFinderClientV0p1Client::send_remove_xrl_from_cache(
	const char*	the_tgt, 
	const string&	xrl, 
	const CB1&	cb
)
{
    Xrl x(the_tgt, "finder_client/0.1/remove_xrl_from_cache");
    x.args().add("xrl", xrl);
    return _router->send(x, callback(this, &XrlFinderClientV0p1Client::unmarshall1, cb));
}


/* Unmarshall remove_xrl_from_cache */
void
XrlFinderClientV0p1Client::unmarshall1(
	const XrlError&	e, 
	XrlRouter&	/* r */, 
	const Xrl&	/* x */, 
	XrlArgs*	a, 
	CB1		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%d != 0)", a->size());
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlFinderClientV0p1Client::send_remove_xrls_for_target_from_cache(
	const char*	the_tgt, 
	const string&	target_name, 
	const CB2&	cb
)
{
    Xrl x(the_tgt, "finder_client/0.1/remove_xrls_for_target_from_cache");
    x.args().add("target_name", target_name);
    return _router->send(x, callback(this, &XrlFinderClientV0p1Client::unmarshall2, cb));
}


/* Unmarshall remove_xrls_for_target_from_cache */
void
XrlFinderClientV0p1Client::unmarshall2(
	const XrlError&	e, 
	XrlRouter&	/* r */, 
	const Xrl&	/* x */, 
	XrlArgs*	a, 
	CB2		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%d != 0)", a->size());
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}
