/*
 * Copyright (c) 2002 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by '../scripts/tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/bgp_base.hh,v 1.1.1.1 2002/12/11 23:56:18 hodson Exp $
 */


#ifndef __XRL_INTERFACES_BGP_BASE_HH__
#define __XRL_INTERFACES_BGP_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlBgpTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrlrouter.hh"

class XrlBgpTargetBase {
protected:
    XrlCmdMap* _router;
    
public:
    XrlBgpTargetBase(XrlCmdMap* r) : _router(r) { add_handlers(); }
    virtual ~XrlBgpTargetBase() { remove_handlers(); }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get local config
     *  
     *  @param id our BGP ID.
     */
    virtual XrlCmdError bgp_0_2_local_config(
	// Input values, 
	const uint32_t&	as, 
	const IPv4&	id) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Set the local AS number.
     *  
     *  @param as our AS number.
     */
    virtual XrlCmdError bgp_0_2_set_local_as(
	// Input values, 
	const uint32_t&	as) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Set the BGP id.
     *  
     *  @param id our BGP ID.
     */
    virtual XrlCmdError bgp_0_2_set_bgpid(
	// Input values, 
	const IPv4&	id) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Add peer.
     *  
     *  @param as the peer's AS number.
     *  
     *  @param next_hop the local next hop.
     *  
     *  @param holdtime expects traffic in this time interval.
     */
    virtual XrlCmdError bgp_0_2_add_peer(
	// Input values, 
	const string&	local_ip, 
	const uint32_t&	local_port, 
	const string&	peer_ip, 
	const uint32_t&	peer_port, 
	const uint32_t&	as, 
	const IPv4&	next_hop, 
	const uint32_t&	holdtime) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Delete peer.
     *  
     *  @param as the peer's AS number.
     */
    virtual XrlCmdError bgp_0_2_delete_peer(
	// Input values, 
	const string&	local_ip, 
	const uint32_t&	local_port, 
	const string&	peer_ip, 
	const uint32_t&	peer_port, 
	const uint32_t&	as) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Enable this peer.
     */
    virtual XrlCmdError bgp_0_2_enable_peer(
	// Input values, 
	const string&	local_ip, 
	const uint32_t&	local_port, 
	const string&	peer_ip, 
	const uint32_t&	peer_port) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Disable this peer.
     */
    virtual XrlCmdError bgp_0_2_disable_peer(
	// Input values, 
	const string&	local_ip, 
	const uint32_t&	local_port, 
	const string&	peer_ip, 
	const uint32_t&	peer_port) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Set the peer state enabled or disabled.
     *  
     *  @param toggle enabled or disabled.
     */
    virtual XrlCmdError bgp_0_2_set_peer_state(
	// Input values, 
	const string&	local_ip, 
	const uint32_t&	local_port, 
	const string&	peer_ip, 
	const uint32_t&	peer_port, 
	const bool&	toggle) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register rib.
     *  
     *  @param name rib name.
     */
    virtual XrlCmdError bgp_0_2_register_rib(
	// Input values, 
	const string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  add route
     *  
     *  @param origin the origin of the path information.
     *  
     *  @param next_hop the border router that should be used as a detination
     *  for the nlri.
     *  
     *  @param nlri network level reachability information.
     */
    virtual XrlCmdError bgp_0_2_add_route(
	// Input values, 
	const int32_t&	origin, 
	const int32_t&	asnum, 
	const IPv4&	next_hop, 
	const IPv4Net&	nlri) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  delete route
     *  
     *  @param nlri network level reachability information.
     */
    virtual XrlCmdError bgp_0_2_delete_route(
	// Input values, 
	const IPv4Net&	nlri) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Terminate bgp process
     */
    virtual XrlCmdError bgp_0_2_terminate() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Set which parameters we support per peer
     */
    virtual XrlCmdError bgp_0_2_set_parameter(
	// Input values, 
	const string&	local_ip, 
	const uint32_t&	local_port, 
	const string&	peer_ip, 
	const uint32_t&	peer_port, 
	const string&	parameter) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Route Info Changed route_info_changed is called by the RIB on the RIB
     *  client (typically a routing protocol) that had registered an interest
     *  in the routing of an address. This can be because the metric and/or
     *  nexthop changed.
     *  
     *  @param addr base address of the subnet that was registered
     *  
     *  @param prefix_len prefix length of the subnet that was registered
     */
    virtual XrlCmdError rib_client_0_1_route_info_changed4(
	// Input values, 
	const IPv4&	addr, 
	const uint32_t&	prefix_len, 
	const IPv4&	nexthop, 
	const uint32_t&	metric) = 0;

    virtual XrlCmdError rib_client_0_1_route_info_changed6(
	// Input values, 
	const IPv6&	addr, 
	const uint32_t&	prefix_len, 
	const IPv6&	nexthop, 
	const uint32_t&	metric) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Route Info Invalid route_info_invalid is called by the RIB on the RIB
     *  client (typically a routing protocol) that had registere d an interest
     *  in the routing of an address. This can be because the information
     *  previously reported as applying no longer applies for any number of
     *  reasons. When the RIB sends this message, it has automatically
     *  de-registered interest in the route, and the client will normally need
     *  to send a register_interest request again.
     */
    virtual XrlCmdError rib_client_0_1_route_info_invalid4(
	// Input values, 
	const IPv4&	addr, 
	const uint32_t&	prefix_len) = 0;

    virtual XrlCmdError rib_client_0_1_route_info_invalid6(
	// Input values, 
	const IPv6&	addr, 
	const uint32_t&	prefix_len) = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_common_0_1_get_version(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_local_config(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_set_local_as(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_set_bgpid(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_add_peer(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_delete_peer(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_enable_peer(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_disable_peer(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_set_peer_state(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_register_rib(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_add_route(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_delete_route(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_terminate(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_bgp_0_2_set_parameter(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_rib_client_0_1_route_info_changed4(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_rib_client_0_1_route_info_changed6(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_rib_client_0_1_route_info_invalid4(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_rib_client_0_1_route_info_invalid6(const Xrl& x, XrlArgs* a);

    void add_handlers()
    {
	if (_router->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlBgpTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/common/0.1/get_target_name");
	}
	if (_router->add_handler("common/0.1/get_version", 
	    callback(this, &XrlBgpTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/common/0.1/get_version");
	}
	if (_router->add_handler("bgp/0.2/local_config", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_local_config)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/local_config");
	}
	if (_router->add_handler("bgp/0.2/set_local_as", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_set_local_as)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/set_local_as");
	}
	if (_router->add_handler("bgp/0.2/set_bgpid", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_set_bgpid)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/set_bgpid");
	}
	if (_router->add_handler("bgp/0.2/add_peer", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_add_peer)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/add_peer");
	}
	if (_router->add_handler("bgp/0.2/delete_peer", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_delete_peer)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/delete_peer");
	}
	if (_router->add_handler("bgp/0.2/enable_peer", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_enable_peer)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/enable_peer");
	}
	if (_router->add_handler("bgp/0.2/disable_peer", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_disable_peer)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/disable_peer");
	}
	if (_router->add_handler("bgp/0.2/set_peer_state", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_set_peer_state)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/set_peer_state");
	}
	if (_router->add_handler("bgp/0.2/register_rib", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_register_rib)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/register_rib");
	}
	if (_router->add_handler("bgp/0.2/add_route", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_add_route)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/add_route");
	}
	if (_router->add_handler("bgp/0.2/delete_route", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_delete_route)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/delete_route");
	}
	if (_router->add_handler("bgp/0.2/terminate", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_terminate)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/terminate");
	}
	if (_router->add_handler("bgp/0.2/set_parameter", 
	    callback(this, &XrlBgpTargetBase::handle_bgp_0_2_set_parameter)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/bgp/0.2/set_parameter");
	}
	if (_router->add_handler("rib_client/0.1/route_info_changed4", 
	    callback(this, &XrlBgpTargetBase::handle_rib_client_0_1_route_info_changed4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/rib_client/0.1/route_info_changed4");
	}
	if (_router->add_handler("rib_client/0.1/route_info_changed6", 
	    callback(this, &XrlBgpTargetBase::handle_rib_client_0_1_route_info_changed6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/rib_client/0.1/route_info_changed6");
	}
	if (_router->add_handler("rib_client/0.1/route_info_invalid4", 
	    callback(this, &XrlBgpTargetBase::handle_rib_client_0_1_route_info_invalid4)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/rib_client/0.1/route_info_invalid4");
	}
	if (_router->add_handler("rib_client/0.1/route_info_invalid6", 
	    callback(this, &XrlBgpTargetBase::handle_rib_client_0_1_route_info_invalid6)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://bgp/rib_client/0.1/route_info_invalid6");
	}
    }

    void remove_handlers()
    {
	_router->remove_handler("common/0.1/get_target_name");
	_router->remove_handler("common/0.1/get_version");
	_router->remove_handler("bgp/0.2/local_config");
	_router->remove_handler("bgp/0.2/set_local_as");
	_router->remove_handler("bgp/0.2/set_bgpid");
	_router->remove_handler("bgp/0.2/add_peer");
	_router->remove_handler("bgp/0.2/delete_peer");
	_router->remove_handler("bgp/0.2/enable_peer");
	_router->remove_handler("bgp/0.2/disable_peer");
	_router->remove_handler("bgp/0.2/set_peer_state");
	_router->remove_handler("bgp/0.2/register_rib");
	_router->remove_handler("bgp/0.2/add_route");
	_router->remove_handler("bgp/0.2/delete_route");
	_router->remove_handler("bgp/0.2/terminate");
	_router->remove_handler("bgp/0.2/set_parameter");
	_router->remove_handler("rib_client/0.1/route_info_changed4");
	_router->remove_handler("rib_client/0.1/route_info_changed6");
	_router->remove_handler("rib_client/0.1/route_info_invalid4");
	_router->remove_handler("rib_client/0.1/route_info_invalid6");
    }
};

#endif /* __XRL_INTERFACES_BGP_BASE_HH__ */
