/*
 * Copyright (c) 2002 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by '../scripts/tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/demo_fea_ifmgr_client_base.hh,v 1.1.1.1 2002/12/11 23:56:18 hodson Exp $
 */


#ifndef __XRL_INTERFACES_DEMO_FEA_IFMGR_CLIENT_BASE_HH__
#define __XRL_INTERFACES_DEMO_FEA_IFMGR_CLIENT_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlDemoFeaIfmgrClientTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrlrouter.hh"

class XrlDemoFeaIfmgrClientTargetBase {
protected:
    XrlCmdMap* _router;
    
public:
    XrlDemoFeaIfmgrClientTargetBase(XrlCmdMap* r) : _router(r) { add_handlers(); }
    virtual ~XrlDemoFeaIfmgrClientTargetBase() { remove_handlers(); }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    virtual XrlCmdError fea_ifmgr_client_0_1_interface_update(
	// Input values, 
	const string&	ifname, 
	const uint32_t&	event) = 0;

    virtual XrlCmdError fea_ifmgr_client_0_1_vif_update(
	// Input values, 
	const string&	ifname, 
	const string&	vifname, 
	const uint32_t&	event) = 0;

    virtual XrlCmdError fea_ifmgr_client_0_1_vifaddr4_update(
	// Input values, 
	const string&	ifname, 
	const string&	vifname, 
	const IPv4&	addr, 
	const uint32_t&	event) = 0;

    virtual XrlCmdError fea_ifmgr_client_0_1_vifaddr6_update(
	// Input values, 
	const string&	ifname, 
	const string&	vifname, 
	const IPv6&	addr, 
	const uint32_t&	event) = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_common_0_1_get_version(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_fea_ifmgr_client_0_1_interface_update(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_fea_ifmgr_client_0_1_vif_update(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_fea_ifmgr_client_0_1_vifaddr4_update(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_fea_ifmgr_client_0_1_vifaddr6_update(const Xrl& x, XrlArgs* a);

    void add_handlers()
    {
	if (_router->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlDemoFeaIfmgrClientTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://demo_fea_ifmgr_client/common/0.1/get_target_name");
	}
	if (_router->add_handler("common/0.1/get_version", 
	    callback(this, &XrlDemoFeaIfmgrClientTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://demo_fea_ifmgr_client/common/0.1/get_version");
	}
	if (_router->add_handler("fea_ifmgr_client/0.1/interface_update", 
	    callback(this, &XrlDemoFeaIfmgrClientTargetBase::handle_fea_ifmgr_client_0_1_interface_update)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://demo_fea_ifmgr_client/fea_ifmgr_client/0.1/interface_update");
	}
	if (_router->add_handler("fea_ifmgr_client/0.1/vif_update", 
	    callback(this, &XrlDemoFeaIfmgrClientTargetBase::handle_fea_ifmgr_client_0_1_vif_update)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://demo_fea_ifmgr_client/fea_ifmgr_client/0.1/vif_update");
	}
	if (_router->add_handler("fea_ifmgr_client/0.1/vifaddr4_update", 
	    callback(this, &XrlDemoFeaIfmgrClientTargetBase::handle_fea_ifmgr_client_0_1_vifaddr4_update)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://demo_fea_ifmgr_client/fea_ifmgr_client/0.1/vifaddr4_update");
	}
	if (_router->add_handler("fea_ifmgr_client/0.1/vifaddr6_update", 
	    callback(this, &XrlDemoFeaIfmgrClientTargetBase::handle_fea_ifmgr_client_0_1_vifaddr6_update)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://demo_fea_ifmgr_client/fea_ifmgr_client/0.1/vifaddr6_update");
	}
    }

    void remove_handlers()
    {
	_router->remove_handler("common/0.1/get_target_name");
	_router->remove_handler("common/0.1/get_version");
	_router->remove_handler("fea_ifmgr_client/0.1/interface_update");
	_router->remove_handler("fea_ifmgr_client/0.1/vif_update");
	_router->remove_handler("fea_ifmgr_client/0.1/vifaddr4_update");
	_router->remove_handler("fea_ifmgr_client/0.1/vifaddr6_update");
    }
};

#endif /* __XRL_INTERFACES_DEMO_FEA_IFMGR_CLIENT_BASE_HH__ */
