/*
 * Copyright (c) 2002 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by '../scripts/tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/finder_base.hh,v 1.1.1.1 2002/12/11 23:56:18 hodson Exp $
 */


#ifndef __XRL_INTERFACES_FINDER_BASE_HH__
#define __XRL_INTERFACES_FINDER_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlFinderTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrlrouter.hh"

class XrlFinderTargetBase {
protected:
    XrlCmdMap* _router;
    
public:
    XrlFinderTargetBase(XrlCmdMap* r) : _router(r) { add_handlers(); }
    virtual ~XrlFinderTargetBase() { remove_handlers(); }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Fails if target_name is already registered. The target_name must
     *  support the finder_client interface in order to be able to process
     *  messages from the finder.
     */
    virtual XrlCmdError finder_0_1_register_xrl_target(
	// Input values, 
	const string&	target_name, 
	const string&	callback_pf, 
	const string&	callback_pf_addr, 
	// Output values, 
	string&	target_cookie) = 0;

    virtual XrlCmdError finder_0_1_unregister_xrl_target(
	// Input values, 
	const string&	target_cookie) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Add resolved Xrl into system, fails if xrl is already registered.
     */
    virtual XrlCmdError finder_0_1_add_xrl(
	// Input values, 
	const string&	target_cookie, 
	const string&	xrl, 
	const string&	protocol_name, 
	const string&	protocol_args, 
	// Output values, 
	string&	resolved_xrl_method_name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Remove xrl
     */
    virtual XrlCmdError finder_0_1_remove_xrl(
	// Input values, 
	const string&	target_cookie, 
	const string&	xrl) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Forcibly add xrl. The Xrl will remain in the cache indefinitely and is
     *  only removable with forcibly_remove_xrl
     */
    virtual XrlCmdError finder_0_1_add_xrl_override(
	// Input values, 
	const string&	target_cookie, 
	const string&	xrl, 
	const string&	protocol_name, 
	const string&	protocol_args, 
	// Output values, 
	string&	resolved_xrl_method_name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Forcibly remove_xrl
     */
    virtual XrlCmdError finder_0_1_remove_xrl_override(
	// Input values, 
	const string&	target_cookie, 
	const string&	xrl) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Resolve xrl
     */
    virtual XrlCmdError finder_0_1_resolve_xrl(
	// Input values, 
	const string&	target_cookie, 
	const string&	xrl, 
	// Output values, 
	string&	resolved_xrl) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get information on Xrl
     */
    virtual XrlCmdError finder_0_1_get_xrl_info(
	// Input values, 
	const string&	target_cookie, 
	const string&	xrl, 
	// Output values, 
	string&	resolved_xrl, 
	string&	registered_by, 
	string&	when) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get list of registered Xrl targets
     */
    virtual XrlCmdError finder_0_1_get_xrl_targets(
	// Output values, 
	XrlAtomList&	target_names) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get list of Xrls registered by target
     */
    virtual XrlCmdError finder_0_1_get_xrls_registered_by(
	// Input values, 
	const string&	target_name, 
	// Output values, 
	XrlAtomList&	xrls) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get list of all Xrls registered with finder
     */
    virtual XrlCmdError finder_0_1_get_all_xrls(
	// Output values, 
	XrlAtomList&	xrls) = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_common_0_1_get_version(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_register_xrl_target(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_unregister_xrl_target(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_add_xrl(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_remove_xrl(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_add_xrl_override(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_remove_xrl_override(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_resolve_xrl(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_get_xrl_info(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_get_xrl_targets(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_get_xrls_registered_by(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_finder_0_1_get_all_xrls(const Xrl& x, XrlArgs* a);

    void add_handlers()
    {
	if (_router->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlFinderTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/common/0.1/get_target_name");
	}
	if (_router->add_handler("common/0.1/get_version", 
	    callback(this, &XrlFinderTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/common/0.1/get_version");
	}
	if (_router->add_handler("finder/0.1/register_xrl_target", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_register_xrl_target)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/register_xrl_target");
	}
	if (_router->add_handler("finder/0.1/unregister_xrl_target", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_unregister_xrl_target)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/unregister_xrl_target");
	}
	if (_router->add_handler("finder/0.1/add_xrl", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_add_xrl)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/add_xrl");
	}
	if (_router->add_handler("finder/0.1/remove_xrl", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_remove_xrl)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/remove_xrl");
	}
	if (_router->add_handler("finder/0.1/add_xrl_override", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_add_xrl_override)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/add_xrl_override");
	}
	if (_router->add_handler("finder/0.1/remove_xrl_override", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_remove_xrl_override)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/remove_xrl_override");
	}
	if (_router->add_handler("finder/0.1/resolve_xrl", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_resolve_xrl)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/resolve_xrl");
	}
	if (_router->add_handler("finder/0.1/get_xrl_info", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_get_xrl_info)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/get_xrl_info");
	}
	if (_router->add_handler("finder/0.1/get_xrl_targets", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_get_xrl_targets)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/get_xrl_targets");
	}
	if (_router->add_handler("finder/0.1/get_xrls_registered_by", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_get_xrls_registered_by)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/get_xrls_registered_by");
	}
	if (_router->add_handler("finder/0.1/get_all_xrls", 
	    callback(this, &XrlFinderTargetBase::handle_finder_0_1_get_all_xrls)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://finder/finder/0.1/get_all_xrls");
	}
    }

    void remove_handlers()
    {
	_router->remove_handler("common/0.1/get_target_name");
	_router->remove_handler("common/0.1/get_version");
	_router->remove_handler("finder/0.1/register_xrl_target");
	_router->remove_handler("finder/0.1/unregister_xrl_target");
	_router->remove_handler("finder/0.1/add_xrl");
	_router->remove_handler("finder/0.1/remove_xrl");
	_router->remove_handler("finder/0.1/add_xrl_override");
	_router->remove_handler("finder/0.1/remove_xrl_override");
	_router->remove_handler("finder/0.1/resolve_xrl");
	_router->remove_handler("finder/0.1/get_xrl_info");
	_router->remove_handler("finder/0.1/get_xrl_targets");
	_router->remove_handler("finder/0.1/get_xrls_registered_by");
	_router->remove_handler("finder/0.1/get_all_xrls");
    }
};

#endif /* __XRL_INTERFACES_FINDER_BASE_HH__ */
