/*
 * Copyright (c) 2002 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by '../scripts/tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/test_base.hh,v 1.1.1.1 2002/12/11 23:56:19 hodson Exp $
 */


#ifndef __XRL_INTERFACES_TEST_BASE_HH__
#define __XRL_INTERFACES_TEST_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlTestTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrlrouter.hh"

class XrlTestTargetBase {
protected:
    XrlCmdMap* _router;
    
public:
    XrlTestTargetBase(XrlCmdMap* r) : _router(r) { add_handlers(); }
    virtual ~XrlTestTargetBase() { remove_handlers(); }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Print hello world
     */
    virtual XrlCmdError test_1_0_print_hello_world() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Print "hello world" and a user supplied greeting.
     *  
     *  @param msg greeting to be printed.
     */
    virtual XrlCmdError test_1_0_print_hello_world_and_message(
	// Input values, 
	const string&	msg) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Count number of greetings available
     */
    virtual XrlCmdError test_1_0_get_greeting_count(
	// Output values, 
	int32_t&	num_msgs) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get greeting
     *  
     *  @param greeting_num index of greeting
     *  
     *  @param greeting text of greeting.
     */
    virtual XrlCmdError test_1_0_get_greeting(
	// Input values, 
	const int32_t&	greeting_num, 
	// Output values, 
	string&	greeting) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Something that always fails.
     */
    virtual XrlCmdError test_1_0_shoot_foot() = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_common_0_1_get_version(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_1_0_print_hello_world(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_1_0_print_hello_world_and_message(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_1_0_get_greeting_count(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_1_0_get_greeting(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_1_0_shoot_foot(const Xrl& x, XrlArgs* a);

    void add_handlers()
    {
	if (_router->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlTestTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/common/0.1/get_target_name");
	}
	if (_router->add_handler("common/0.1/get_version", 
	    callback(this, &XrlTestTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/common/0.1/get_version");
	}
	if (_router->add_handler("test/1.0/print_hello_world", 
	    callback(this, &XrlTestTargetBase::handle_test_1_0_print_hello_world)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/test/1.0/print_hello_world");
	}
	if (_router->add_handler("test/1.0/print_hello_world_and_message", 
	    callback(this, &XrlTestTargetBase::handle_test_1_0_print_hello_world_and_message)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/test/1.0/print_hello_world_and_message");
	}
	if (_router->add_handler("test/1.0/get_greeting_count", 
	    callback(this, &XrlTestTargetBase::handle_test_1_0_get_greeting_count)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/test/1.0/get_greeting_count");
	}
	if (_router->add_handler("test/1.0/get_greeting", 
	    callback(this, &XrlTestTargetBase::handle_test_1_0_get_greeting)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/test/1.0/get_greeting");
	}
	if (_router->add_handler("test/1.0/shoot_foot", 
	    callback(this, &XrlTestTargetBase::handle_test_1_0_shoot_foot)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test/test/1.0/shoot_foot");
	}
    }

    void remove_handlers()
    {
	_router->remove_handler("common/0.1/get_target_name");
	_router->remove_handler("common/0.1/get_version");
	_router->remove_handler("test/1.0/print_hello_world");
	_router->remove_handler("test/1.0/print_hello_world_and_message");
	_router->remove_handler("test/1.0/get_greeting_count");
	_router->remove_handler("test/1.0/get_greeting");
	_router->remove_handler("test/1.0/shoot_foot");
    }
};

#endif /* __XRL_INTERFACES_TEST_BASE_HH__ */
