/*
 * Copyright (c) 2002 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by '../scripts/tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/test_peer_base.hh,v 1.1.1.1 2002/12/11 23:56:19 hodson Exp $
 */


#ifndef __XRL_INTERFACES_TEST_PEER_BASE_HH__
#define __XRL_INTERFACES_TEST_PEER_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlTestPeerTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrlrouter.hh"

class XrlTestPeerTargetBase {
protected:
    XrlCmdMap* _router;
    
public:
    XrlTestPeerTargetBase(XrlCmdMap* r) : _router(r) { add_handlers(); }
    virtual ~XrlTestPeerTargetBase() { remove_handlers(); }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Register for receiving packets and events.
     */
    virtual XrlCmdError test_peer_0_1_register(
	// Input values, 
	const string&	coordinator) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Packetisation style.
     */
    virtual XrlCmdError test_peer_0_1_packetisation(
	// Input values, 
	const string&	protocol) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Make a tcp connection to the specified host and port.
     *  
     *  @param host name.
     *  
     *  @param port number.
     */
    virtual XrlCmdError test_peer_0_1_connect(
	// Input values, 
	const string&	host, 
	const uint32_t&	port) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Listen for connections on this address and port.
     *  
     *  @param address local address.
     *  
     *  @param port local port number.
     */
    virtual XrlCmdError test_peer_0_1_listen(
	// Input values, 
	const string&	address, 
	const uint32_t&	port) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Send data Send data to the peer.
     */
    virtual XrlCmdError test_peer_0_1_send(
	// Input values, 
	const vector<uint8_t>&	data) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Disconnect from the peer.
     */
    virtual XrlCmdError test_peer_0_1_disconnect() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Reset the peer. Take it back to a known state.
     */
    virtual XrlCmdError test_peer_0_1_reset() = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *  
     *  Terminate the test peer process.
     */
    virtual XrlCmdError test_peer_0_1_terminate() = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_common_0_1_get_version(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_register(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_packetisation(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_connect(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_listen(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_send(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_disconnect(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_reset(const Xrl& x, XrlArgs* a);

    const XrlCmdError handle_test_peer_0_1_terminate(const Xrl& x, XrlArgs* a);

    void add_handlers()
    {
	if (_router->add_handler("common/0.1/get_target_name", 
	    callback(this, &XrlTestPeerTargetBase::handle_common_0_1_get_target_name)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/common/0.1/get_target_name");
	}
	if (_router->add_handler("common/0.1/get_version", 
	    callback(this, &XrlTestPeerTargetBase::handle_common_0_1_get_version)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/common/0.1/get_version");
	}
	if (_router->add_handler("test_peer/0.1/register", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_register)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/register");
	}
	if (_router->add_handler("test_peer/0.1/packetisation", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_packetisation)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/packetisation");
	}
	if (_router->add_handler("test_peer/0.1/connect", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_connect)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/connect");
	}
	if (_router->add_handler("test_peer/0.1/listen", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_listen)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/listen");
	}
	if (_router->add_handler("test_peer/0.1/send", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_send)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/send");
	}
	if (_router->add_handler("test_peer/0.1/disconnect", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_disconnect)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/disconnect");
	}
	if (_router->add_handler("test_peer/0.1/reset", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_reset)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/reset");
	}
	if (_router->add_handler("test_peer/0.1/terminate", 
	    callback(this, &XrlTestPeerTargetBase::handle_test_peer_0_1_terminate)) == false) {
	    XLOG_ERROR("Failed to xrl handler finder://test_peer/test_peer/0.1/terminate");
	}
    }

    void remove_handlers()
    {
	_router->remove_handler("common/0.1/get_target_name");
	_router->remove_handler("common/0.1/get_version");
	_router->remove_handler("test_peer/0.1/register");
	_router->remove_handler("test_peer/0.1/packetisation");
	_router->remove_handler("test_peer/0.1/connect");
	_router->remove_handler("test_peer/0.1/listen");
	_router->remove_handler("test_peer/0.1/send");
	_router->remove_handler("test_peer/0.1/disconnect");
	_router->remove_handler("test_peer/0.1/reset");
	_router->remove_handler("test_peer/0.1/terminate");
    }
};

#endif /* __XRL_INTERFACES_TEST_PEER_BASE_HH__ */
